clear 
load data03.mat

for j = 1:20
    step = 5;
    y_offset = (j-1)*step*pi/180;


y = pm*pi/180 + y_offset;

T = 0.02;
start = 2;
stop = length(t);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

%fft_viz(y,T)

order_fir = 10;       % FIR filter order
Fp  = 1; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

%
[Theta yhat] = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt);
   

ic = 1;
opts = odeset('RelTol',1e-2,'AbsTol',1e-4);

%yddot + ydot + sin(y + offset) = u
yfull = [0 0];
tfull = 0;
for k = 2:1:100
    tspan = [k-1+0.5 k+0.5];
    [tode,yode] = ode45(@(tode,yode) pendulumEq(tode, yode , u, t, Theta, y_offset), tspan, [yf((k-1+0.5)/T+1), ydotf((k-1+0.5)/T+1)]);
    yfull = [yfull; yode];
    tfull = [tfull; tode];
end
len = min([length(yfull)  length(yf)])
e = yfull(1:len,1) - yf(100:len+99);
yfull_ts = [tfull(1:len) yfull(1:len,1)];
yf_ts = [t(100:len-100) yf(100:len-100,1)];

sim('odecet.slx')
NormV(j) = norm(e_odecet)
end

figure
plot(NormV)
% 
% figure
% plot(e)
% figure
% hold on
% plot(tfull(1:len), yfull(1:len,1))
% plot(t(100:len-100), yf(100:len-100,1))
% 
% figure
% hold on
% plot(tfull,yfull(:,1),tfull,yfull(:,2))
% plot(t, pm*pi/180+y_offset)
