clear 
load data03.mat
figure
subplot(2,1,1)
plot(t,u)
subplot(2,1,2)
plot(t,pm)

y = pm*pi/180

T = 0.02

order_fir = 100       % FIR filter order
Wn_fir = 0.5*2*pi % Cutoff frequency (rad/s)

Fp  = Wn_fir/(2*pi)
%Fp = 1
Fs  = 1/T;       
h = fir1(order_fir,Fp/(Fs/2))  % Calculated FIR filter

% Filters the derivative data
start = 2
N = length(t)
k0 = start+(order_fir/2)
kend = N-(order_fir/2)-2
for k = start+(order_fir/2):N-(order_fir/2)-2
    yfd = 0;
    for i = 1:order_fir+1
        yfd = yfd + h(i) * y(k - (order_fir/2) + i);
    end
    yf_fir(k) = yfd;
end

start = k0
N = kend
for k = start:N-1
   ydot(k) = (yf_fir(k+1)-yf_fir(k-1))/(2*T); 
   yddot(k) = (yf_fir(k+1)-2*yf_fir(k)+yf_fir(k-1))/(T^2);
end

figure
subplot(3,1,1)
title('real data')
plot(yf_fir(k0+1:end))
subplot(3,1,2)
plot(ydot(k0+1:end))
subplot(3,1,3)
plot(yddot(k0+1:end))



%% FIR filter

Fp  = Wn_fir/(2*pi)
%Fp = 1
Fs  = 1/T;       
h = fir1(order_fir,Fp/(Fs/2))  % Calculated FIR filter

% Filters the derivative data
k0 = start+(order_fir/2)
kend = N-(order_fir/2)-2
for k = start+(order_fir/2):N-(order_fir/2)-2
    ydotfd = 0;
    yddotfd = 0;
    for i = 1:order_fir+1
        ydotfd = ydotfd + h(i) * ydot(k - (order_fir/2) + i);
        yddotfd = yddotfd + h(i) * yddot(k - (order_fir/2) + i);
    end
    ydotf_fir(k) = ydotfd;
    yddotf_fir(k) = yddotfd;
end

figure
subplot(3,1,1)
title('filtered data')
plot(yf_fir)
subplot(3,1,2)
plot(ydotf_fir)
subplot(3,1,3)
plot(yddotf_fir)
%% FIR Identification
y_offset = 30*pi/180
Nmax = min([length(ydotf_fir) length(yf_fir) length(u)]);
start = max(15,k0);
for n = start:Nmax
    Phi_fir(n-start+1, :) = [ -ydotf_fir(n)  -sin(yf_fir(n) + y_offset)  u(n) sqrt(u(n)) 1];
end

Theta_fir = pinv(Phi_fir)*yddotf_fir(start:Nmax)'

H = Phi_fir*inv(Phi_fir'*Phi_fir)*Phi_fir';

epsilon_fir = (eye(length(H))-H)*yddotf_fir(start:Nmax)';

%MG kontrola rezidua
yhat_fir=Phi_fir*Theta_fir;
e = yddotf_fir(start:Nmax)'-yhat_fir; %kontrola rezidua, jednodussi vypocet nez opet pres inverzi vyse

%MG pozor na pocatecni velkou odchylku v epsilon - ze zaznamu se musi
%vyriznout pocatecni cast, kde filtry pro derivace nejsou jeste
%vysledovane, tady cca od 13 vzorku dal

mean_fir = mean(epsilon_fir) 


s2_fir = ((epsilon_fir-mean_fir)'*(epsilon_fir-mean_fir))/(Nmax-length(Theta_fir))

cove_fir = s2_fir*(eye(length(H))-H);

cov_theta_fir = s2_fir * inv(Phi_fir'*Phi_fir)


figure
subplot(2,1,1)
hold on
title('yhat')
plot(yddotf_fir(start:Nmax))
plot(yhat_fir)
legend('yddotf_fir', 'yhat_fir')
subplot(2,1,2)
plot(e)

