close all
clear
load data03.mat

quantization_step = 0.36

figure
plot(t,pm)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Pitch angle $\varphi [^{\circ}]$','fontsize',14,'interpreter','latex')
title('Optical sensor output','fontsize',14,'interpreter','latex')

figure 
plot(t,u)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Input voltage [0-1]','fontsize',14,'interpreter','latex')
title('Power provided to the motor','fontsize',14,'interpreter','latex')

y = pm*pi/180;
T = 0.02;
start = 2;
stop = length(t);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

figure
plot(t(1:length(t)-1),ydot)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Angular velocity $\dot{\varphi} [^{\circ}/s]$','fontsize',14,'interpreter','latex')
title('Numerical first derivative','fontsize',14,'interpreter','latex')

figure
plot(t(1:length(t)-1),yddot)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Angular acceleration $\ddot{\varphi} [^{\circ}/s^2]$','fontsize',14,'interpreter','latex')
title('Numerical second derivative','fontsize',14,'interpreter','latex')

order_fir = 100;       % FIR filter order
Fp  = 1; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

figure
plot(t(start_after_filt:length(t)-1),yf)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Filtered pitch angle $\varphi_f [^{\circ}/s]$','fontsize',14,'interpreter','latex')
title('Filtered optical sensor output','fontsize',14,'interpreter','latex')

figure
plot(t(start_after_filt:length(t)-1),ydotf)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Filtered angular velocity $\dot{\varphi_f} [^{\circ}/s]$','fontsize',14,'interpreter','latex')
title('Filtered numerical first derivative','fontsize',14,'interpreter','latex')

figure
plot(t(start_after_filt:length(t)-1),yddotf)
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('Filtered angular acceleration $\ddot{\varphi_f} [^{\circ}/s^2]$','fontsize',14,'interpreter','latex')
title('Filtered numerical second derivative','fontsize',14,'interpreter','latex')



