clear all
close all

Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]

y_lin = 130
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F130 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F130,Ts,'zoh')
plant_ss130 = ss(Fd)

% 50 deg
y_lin = 50
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F50 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F50,Ts,'zoh')
plant_ss50 = ss(Fd)


y_lin = 90
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40

s = tf('s')
u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100
%%

A = [[plant_ss.A [0;0] [0;0] [0;0]]; [0 0 1 0 0];[0 0 0 1 0]; [0 0 0 0 1]] 
B = [plant_ss.B; 0; 0; 0]
C = [plant_ss.C 0 0 0]
Ce = [plant_ss.C -1 0 0]
D = plant_ss.D


Ard = [plant_ss.A,plant_ss.B;[0 0 1]]
Brd = [plant_ss.B; 0]
Crd = [plant_ss.C 0]

Ld = acker(Ard',Crd', 4*[0.1 0.1 0.1] )'

Frekd = Ard-Ld*Crd
eig(Frekd)

% parameters
np = 50
nc = 10
% constraints
ub = (1-u0)*ones(nc,1)
lb = (0-u0)*ones(nc,1)
% weights
eW = 1 %output weight
duW = 0.1 %input weight

Q = eW*eye(size(C,1))
R = duW*eye(size(B,2))
cQ = cell(1,np)
cR = cell(1,nc)
cQ(:) = {Q}
cR(:) = {R}
Q = blkdiag(cQ{:}) % np*np
R = blkdiag(cR{:}) % nc*nc

%delta u matrices
K = eye(nc)-triu(ones(nc),-1)+triu(ones(nc),0)
M = zeros(nc,1)
M(1) = -1
L = [0 0 0 1 0]


% prediction matrices
Px = []
Hx = []
P = []
H = []
for r = 1:np
    Hx_row = [];
    H_row = [];
    for c = 1:np
        Hx_row = [Hx_row mat_pow(A, r-c)*B];
        H_row = [H_row Ce*mat_pow(A,r-c-1)*B];
    end
    Hx = [Hx ; Hx_row];
    H = [H ; H_row];
    Px = [Px ; A^r]   ;
    P = [P ; Ce*mat_pow(A,r-1)];
end
H = H - diag(diag(H))+eye(length(H))*D; %uprava prvku na diagonale


% Move blocking
% Mb lze aplikovat na uk nebo na Hx a H (v nasem pripade se aplikuje na Hx a H)
Mb = [eye(nc);[zeros(np-nc,nc-1) ones(np-nc,1)]];
Hbx = Hx*Mb;
Hb = H*Mb;

% Inicializace zaznamovych vektoru
w0 = 0.3 % REFERENCNI SIGNAL
z0 = -0.1
z1 = 0.1
z2 = 0.1

p = (P'*Q*Hb + L'*M'*R*K);
G = (Hb'*Q*Hb + K'*R*K);

phi0 = pi/2
pinv(plant_ss.C)'*phi0
xhat0 = [0 0 -u0]

%%
slope = 0.1
ramp_on = -1

sim('MPCsim_estimatorTuning')

figure
subplot(3,1,1)
hold on
plot(out.PIDvsMPC_simLS.time, out.PIDvsMPC_simLS.Data(:,1))
plot(out.PIDvsMPC_simLS.time, out.PIDvsMPC_simLS.Data(:,2))
legend({'System output $\varphi$', 'Setpoint'},'Interpreter','Latex')
title('MPC control time response','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Output $\varphi$ [rad]','Interpreter','Latex')
subplot(3,1,2)
hold on
plot(out.PIDvsMPC_simLS.time, out.PIDvsMPC_simLS.Data(:,3))
plot(out.PIDvsMPC_simLS.time, out.PIDvsMPC_simLS.Data(:,4))
legend({'Input disturbance $z$', 'Reconstructed disturbance $\hat{z}$'},'Interpreter','Latex')
title('Input disturbance present','Interpreter','Latex')
ylabel('Disturbance','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
subplot(3,1,3)
hold on
plot(out.PIDvsMPC_simLS.time, out.PIDvsMPC_simLS.Data(:,5))
title('MPC control action','Interpreter','Latex')
ylabel('Control $u$','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')

% Measured data
figure
subplot(3,1,1)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,1))
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,2))
legend({'System output $\varphi$', 'Setpoint'},'Interpreter','Latex')
title('MPC control time response','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Output $\varphi$ [rad]','Interpreter','Latex')
subplot(3,1,2)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,3))
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,4))
legend({'Input disturbance $z$', 'Reconstructed disturbance $\hat{z}$'},'Interpreter','Latex')
title('Input disturbance present','Interpreter','Latex')
ylabel('Disturbance','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
subplot(3,1,3)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,5))
title('MPC control action','Interpreter','Latex')
ylabel('Control $u$','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')


% Data from the PoV of MPC controller
figure
subplot(3,1,1)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,1)-phi0)
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,2)-phi0)
legend({'System output $\varphi$', 'Setpoint'},'Interpreter','Latex')
title('MPC control time response','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Output $\varphi$ [rad]','Interpreter','Latex')
subplot(3,1,2)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,3))
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,4)+u0)
legend({'Input disturbance $z$', 'Reconstructed disturbance $\hat{z}$'},'Interpreter','Latex')
title('Input disturbance present','Interpreter','Latex')
ylabel('Disturbance','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
subplot(3,1,3)
hold on
plot(out.PIDvsMPC_simNS.time, out.PIDvsMPC_simNS.Data(:,5))
title('MPC control action','Interpreter','Latex')
ylabel('Control $u$','Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')

